/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قϳƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "device_mouse_task.h"
#include "usb_descriptors.h"

#include "lib_mcu/usb/usb_drv.h"

#include "modules/usb/device_chap9/usb_standard_request.h"

//_____ ϸ ________________________________________________________________

//! @defgroup mouse_report_fill ϳ񍐔z𖞂ϸ
//! @{
#define Hid_mouse_report_up()			(g_hid_mouse_report[2]-=MOUSE_SPEED)
#define Hid_mouse_report_down()			(g_hid_mouse_report[2]+=MOUSE_SPEED)
#define Hid_mouse_report_left()			(g_hid_mouse_report[1]-=MOUSE_SPEED)
#define Hid_mouse_report_right()		(g_hid_mouse_report[1]+=MOUSE_SPEED)

#define Hid_mouse_report_scroll_up()	(g_hid_mouse_report[3]+=MOUSE_SPEED)
#define Hid_mouse_report_scroll_down()	(g_hid_mouse_report[3]-=MOUSE_SPEED)

#define Hid_mouse_report_click_left()	(g_hid_mouse_report[0] |= 0x01)
#define Hid_mouse_report_click_right()	(g_hid_mouse_report[0] |= 0x02)
#define Hid_mouse_report_click_middle()	(g_hid_mouse_report[0] |= 0x04)

#define Hid_mouse_report_reset()		(g_hid_mouse_report[0]=0,g_hid_mouse_report[1]=0,g_hid_mouse_report[2]=0,g_hid_mouse_report[3]=0)
//! @}

//! @defgroup mouse_board_interface ϳۂƂŊqϸ
//! @{
#define Is_mouse_left_event()			Is_joy_left()
#define Is_mouse_right_event()			Is_joy_right()
#define Is_mouse_up_event()				Is_joy_up()
#define Is_mouse_down_event()			Is_joy_down()

#define Is_mouse_scroll_up_event()		FALSE
#define Is_mouse_scroll_down_event()	FALSE

#define Is_mouse_click_left_event()		Is_btn_left()
#define Is_mouse_click_middle_event()	FALSE
#define Is_mouse_click_right_event()	Is_btn_middle()
//! @}

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

bit is_device_mouse_event (void);

Bool g_b_send_report;						//!< o񍐂׸ނɎgp
Bool g_b_send_ack_report;					//!< o񍐂׸ނɎgp
U8 g_hid_mouse_report[4];					//!< HIDϳ񍐂̊i[Ɏgp
//! SOF̌vƌvv쐬Ɏgp
volatile U8  g_u8_cpt_sof   =0;
volatile U16 g_u16_cpt2_sof =0;

//! ̊֐ϳƂɕKvƂʰ޳/ĳ̎܂B
//!
void device_mouse_task_init (void)
{
	// SOF
	Usb_enable_sof_interrupt();

	// ̪
	Joy_init();
	Leds_init();
	Hwb_button_init();

	// nŉ񍐂𑗏o
	g_b_send_report     = FALSE;
	g_b_send_ack_report = TRUE;
}

//! ̊֐͉̌ʂ܂񂪁Av敔ɂČĂ΂܂B͊荞ݏmouse_task_by_IT()ɂĒu܂B
//!
void device_mouse_task (void)
{
	if(Is_usb_id_device())
	{
		Usb_enable_sof_interrupt();			// USB ID߂ωɊ荞݋֎~̏ꍇ
	}
}

//! USB HIDϳuϳۂq
//!
//! @verbatim
//! ̍Ƃ͊荞ݏ܂B֐ڰъJnM̊荞ݏٰ(ISR)IɌĂ΂܂B
//! ͑eʋLgpĂ(Ⴆ̧ٕʂ)Ԃϳ̈ړ\ɂ܂B
//! @endverbatim
//!
void device_mouse_task_by_IT (void)
{
	if(!Is_device_enumerated())
		return;								// us

	if(!g_b_send_report)
	{
		// is̕񍐑oȂ̎ɌǐV񍐂𖞂ϳۂ𒲍
		if(is_device_mouse_event())
		{
			// 񍐂̑o
			g_b_send_report = TRUE;
		}
	}

	if((!g_b_send_report)&&(!g_b_send_ack_report))
		return;								// 񍐂ȂAoɉ								// 񍐂ȂAoɉ

	//** 񍐂܂͉Ȃ΂Ȃ܂B
	Usb_select_endpoint(EP_MOUSE_IN);
	if(!Is_usb_write_enabled())
		return;								// ߲ċ󂫂Ȃ

	if( g_b_send_report )
	{
		g_b_send_report = FALSE;
		// "د"񍐂̌ɉ𑗏o
		g_b_send_ack_report = (0!=g_hid_mouse_report[0]);
	}
	else
	{
		Hid_mouse_report_reset();			// 񍐂߂ɕ񍐂ؾ
		g_b_send_ack_report  = FALSE;
	}
	// 񍐂𑗏o
	Usb_write_byte(g_hid_mouse_report[0]);
	Usb_write_byte(g_hid_mouse_report[1]);
	Usb_write_byte(g_hid_mouse_report[2]);
	Usb_write_byte(g_hid_mouse_report[3]);
	Usb_ack_in_ready();
}

//! ̊֐͊²̪𒲂ׂHIDϳ񍐂𖞂܂B
//!
//! @return	۔̏ꍇTRUEB̏ꍇAHIDϳ񍐂܂B
//! @return	ۂȂ̏ꍇFALSEB
//!
bit is_device_mouse_event (void)
{
	Hid_mouse_report_reset();

	// دے
	if(Is_mouse_click_left_event()) {
		Hid_mouse_report_click_left();
	}
	if(Is_mouse_click_middle_event()) {
		Hid_mouse_report_click_middle();
	}
	if(Is_mouse_click_right_event()) {
		Hid_mouse_report_click_right();
	}

	// ړے
	if (Is_mouse_left_event()) {
		Hid_mouse_report_left();
	}
	if (Is_mouse_right_event()) {
		Hid_mouse_report_right();
	}
	if (Is_mouse_up_event()) {
		Hid_mouse_report_up();
	}
	if (Is_mouse_down_event()) {
		Hid_mouse_report_down();
	}

	// 񍐒
	if((0==g_hid_mouse_report[0])
	&& (0==g_hid_mouse_report[1])
	&& (0==g_hid_mouse_report[2])
	   && (0==g_hid_mouse_report[3]))
	{
		return FALSE;						// ۂȂ
	}
	return TRUE;							// ۔
}

//! ̊֐͂̓xSOFv𑝉܂B
//!
//! @verbatim
//! USBڰъJn荞ݻٰ݂(1ms)s܂B
//! ԒxǗ̂ɗLpłB
//! ̊荞ݏٰ(ISR)́Aǂ̏(eʋLȂ)łϳۏ
//! mouse_task_by_IT()Ăяo܂B
//! @endverbatim
//!
void sof_action()
{
	U8 ep_selected;
	g_u16_cpt2_sof++;
	g_u8_cpt_sof++;
	if (g_u8_cpt_sof == NB_IDLE_POLLING_SOF)
	{
		ep_selected = Usb_get_selected_endpoint();	// eʋL߲Ă̓ǂ/Ɋ荞݂N鎞̖
													// ߂ɁAݑIĂ߲Ă͕ۑȂ΂Ȃ܂B
		device_mouse_task_by_IT();
		g_u8_cpt_sof = 0;
		Usb_select_endpoint(ep_selected);	// ݑIꂽ߲Ă𕜌
	}
}
