/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBν ϳ䉞pǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "host_mouse_task.h"
#include "modules/usb/host_chap9/usb_host_task.h"
#include "modules/usb/host_chap9/usb_host_enum.h"
#include "lib_mcu/usb/usb_drv.h"

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
  #define LOG_STR_CODE(str)
#else
  U8 code log_mouse_connect[]="Mouse Connected";
#endif

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

U8 mouse_connected=0;

U8 pipe_mouse_in;

//!@brief ̊֐νUSBϳp܂B
//!
//!@param	Ȃ
//!
//!@return	Ȃ
void host_mouse_task_init (void)
{
	Leds_init();
}

//! @brief ̊֐ν ϳpǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void host_mouse_task (void)
{
	U8 i;
	S8 new_x,new_y;

	// HIDuڑ
	if(Is_host_ready())
	{
		if(Is_new_device_connection_event())	// uڑ
		{
			mouse_connected=0;
			for(i=0;i<Get_nb_supported_interface();i++)
			{
				if(Get_class(i)==HID_CLASS && Get_protocol(i)==HID_PROTOCOL_MOUSE)
				{
					mouse_connected=1;
					host_hid_set_idle();
					host_get_hid_repport_descriptor();
					LOG_STR_CODE(log_mouse_connect);
					PIPE_MOUSE_IN=host_get_hwd_pipe_nb(Get_ep_addr(i,0));
					Host_select_pipe(PIPE_MOUSE_IN);
					Host_continuous_in_mode();
					Host_unfreeze_pipe();
					break;
				}
			}
		}
		if(mouse_connected)
		{
			Host_select_pipe(PIPE_MOUSE_IN);
			if(Is_host_in_received())
			{
				if(Is_host_stall()==FALSE)
				{
					i=Host_read_byte();
					new_x=(S8)Host_read_byte();
					new_y=(S8)Host_read_byte();

					if(new_x==0)
					{ Led0_off(); Led1_off();}
					else if(new_x>0)
					{Led0_on(); Led1_off();}
					else
					{ Led0_off(); Led1_on();}

					if(new_y==0)
					{ Led2_off(); Led3_off();}
					else if(new_y>0)
					{ Led2_on(); Led3_off();}
					else
					{ Led2_off(); Led3_on();}
				}
				Host_ack_in_received(); Host_send_in();
			}
			if(Is_host_nak_received())
			{
				Host_ack_nak_received();
				Led0_off(); Led1_off();
				Led2_off(); Led3_off();
			}
		}
	}
	// uؒf
	if(Is_device_disconnection_event())
	{
		Leds_off();
		mouse_connected=0;
	}
}
