/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͕WHID IN/OUTƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "hid_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#include "lib_mcu/util/start_boot.h"
#include "lib_mcu/adc/adc_drv.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

extern volatile U16 g_u16_cpt2_sof;
extern U8 jump_bootloader;
#if( HID_GENERIC_DEMO_FULL == ENABLE )
  U8 g_temperature =0;
  U8 g_potentiometer =0;
#else
  U8 g_last_joy =0;
#endif

void hid_report_out (void);
void hid_report_in (void);

//! @brief ̊֐͖ړIΏۊ̎܂B
//!
void hid_task_init (void)
{
#if( HID_GENERIC_DEMO_FULL == ENABLE )
	init_adc();
#endif
	Leds_init();
	Joy_init();
}

//! @brief HIDWʐMƂ̓_
//! ̊֐IN/OUT񍐊ǗǗ܂B
//!
void hid_task (void)
{
	if(!Is_device_enumerated())				// USB HID(ڑF)ꂽ
		return;

	hid_report_out();
	hid_report_in();
}

//! @brief νĂް񍐂𓾂B
//!
void hid_report_out (void)
{
	Usb_select_endpoint(EP_HID_OUT);
	if(Is_usb_receive_out())
	{
#if( HID_GENERIC_DEMO_FULL == ENABLE )
		//* WHIDS񍐂ǂށB
		U8 report_byte_4;
		U8 report_byte_5;
		Leds_set_val(    Usb_read_byte());	// OUT[0]LEDSl
		GPIOR1         = Usb_read_byte();	// (sgp)
		GPIOR1         = Usb_read_byte();	// (sgp)
		report_byte_4  = Usb_read_byte();
		report_byte_5  = Usb_read_byte();
		// νĂDFU얽߂󂯎
		if( (report_byte_4==0x55) && (report_byte_5==0xAA) )
			jump_bootloader = TRUE;
#else
		//* WHID񍐂ǂށB
		U8 led_state;
		U8 led_number;
		led_state  = Usb_read_byte()&0x0F;	// OUT[0]LEDSl
		led_number = Usb_read_byte()&0x0F;
		switch (led_number)
		{
			case 1:
				if(led_state)
				{ Led0_on(); }
				else {Led0_off();}
				break;
			case 2:
				if(led_state)
				{ Led1_on(); }
				else {Led1_off();}
				break;
			case 3:
				if(led_state)
				{ Led2_on(); }
				else {Led2_off();}
				break;
			case 4:
				if(led_state)
				{ Led3_on(); }
				else {Led3_off();}
				break;
		}
#endif
	Usb_ack_receive_out();
	}

	//** νĂDFU얽߂󂯎
	if(jump_bootloader)
	{
		U32 volatile tempo;
		Leds_off();
		Usb_detach();						// ۂ̕WHIDpt
		for(tempo=0;tempo<70000;tempo++);	// ް۰ނ֔ԑOɈ鎞ԑҋ@
		start_boot();
	}
}

//! @brief νĂް񍐂𑗂B
//!
void hid_report_in (void)
{
	U8 joy =0;

	Usb_select_endpoint(EP_HID_IN);
	if(!Is_usb_write_enabled())
		return;								// 񍐑oĂȂB

#if( HID_GENERIC_DEMO_FULL == ENABLE )
  #if (TARGET_BOARD!=USBKEY)
	if (g_u16_cpt2_sof%100==0)
	{
		g_potentiometer=Get_adc_pot_val()>>2;
	}
  #endif
	if (g_u16_cpt2_sof>=600)
	{
		g_temperature=(S8)Read_temperature();
		g_temperature=(S8)Read_temperature();
		g_u16_cpt2_sof=0;
	}
	// ޮè񍐂\z
	if(Is_joy_up())							// ی
	{
		joy+=0x01;
	}
	if(Is_joy_down())						// ی
	{
		joy+=0x02;
	}
	if(Is_joy_right())						// ی
	{
		joy+=0x04;
	}
	if(Is_joy_left())						// ی
	{
		joy+=0x08;
	}
#else
	// ޮè񍐂\z
	if(Is_joy_up()|| Is_joy_down() || Is_joy_right() || Is_joy_left() )	// ی
	{
		joy=0x01;
	}
	if(joy==g_last_joy)
		return;								// 񍐂͕̎񍐑oȂ
	g_last_joy=joy;
#endif

	// 񍐑o
#if( HID_GENERIC_DEMO_FULL == ENABLE )
	Usb_write_byte(Leds_get_val());			// LED
	Usb_write_byte(joy);					// ޮè
	Usb_write_byte(g_potentiometer);		// ϒR
	Usb_write_byte(g_temperature);			// x
#else
	Usb_write_byte(g_last_joy);				// ޮè
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_write_byte(GPIOR1);					// U(sgp)
#endif
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_write_byte(GPIOR1);					// U(sgp)
	Usb_ack_in_ready();						// USBްo
}
